<template>
  <template-page ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
    :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
    :operation="operation()">
    <el-dialog title="" width="500px" custom-class="diy-dialog" append-to-body :modal="true" :visible.sync="formDialog"
      :show-close="true" :close-on-click-modal="false" :modal-append-to-body="false" :before-close="formCancel">
      <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
        <zj-form-module :title="formDialogTitles[formDialogType]" label-width="120px" :showPackUp="false"
          :form-data="formData" :form-items="formItems">
        </zj-form-module>
      </zj-form-container>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="formCancel">取 消</el-button>
        <el-button v-if="this.formDialogType !== 2" size="mini" @click="formConfirm" type="primary">确 定</el-button>
      </div>
    </el-dialog>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { chargingStandardTypeList2, getTypeList, getTypeDetail, saveType, deleteType } from "@/api/miniapp";
import ImageUpload from '@/components/file-upload'
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage, ImageUpload },
  mixins: [import_mixin,operation_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "查看"],
      formDialog: false,
      formData: {
        name: "",
        status: true,
		sortNum: 0
      },
    }
  },
  computed: {
	// 事件组合
	optionsEvensGroup() {
		return [
			[
				[
					this.optionsEvensAuth("add", {
						click: () => {
							this.addData()
						}
					})
				],
			]
		]
	},
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 24,
        isShow: true,
        name: 'el-input',
        options: this.businessTypeList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '名称',
          prop: 'name',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-radio',
        options: [{ label: "开启", value: true }, { label: "禁用", value: false }],
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2 },
        formItemAttributes: {
          label: '状态',
          prop: 'status',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '排序',
          prop: 'sortNum',
          rules: [...required]
        }
      }
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: chargingStandardTypeList2,
    // 列表导出函数
    exportList() { },
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
	// 表格操作列
	operation() {
		return this.operationBtn({
			detail: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					getTypeDetail({ id: row.id }).then(res => {
					  Object.assign(this.formData, res.data)
					  this.formDialogType = 2
					  this.openForm()
					})
				}
			},
			edit: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					getTypeDetail({ id: row.id }).then(res => {
					  Object.assign(this.formData, res.data)
					  this.formDialogType = 1
					  this.openForm()
					})
				}
			},
			del: {
				btnType: 'text',
				prompt: '确定删除吗？',
				click: ({ row, index, column }) => {
					deleteType({ id: row.id }).then(res => {
					  this.$message({
					    type: 'success',
					    message: `删除成功!`,
					  })
					  this.$refs.pageRef.refreshList()
					})
				}
			}
		})
	},
    addData() {
      this.formDialogType = 0
      this.openForm()
    },
    openForm() {
      this.formDialog = true;
    },
    formCancel() {
      this.$refs.formRef.$refs.inlineForm.clearValidate()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
    formConfirm() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          saveType(this.formData).then(res => {
            this.$message({
              type: 'success',
              message: this.formDialogTitles[this.formDialogType] + `成功!`,
            })
            this.formCancel()
            this.$refs.pageRef.refreshList()
          })
        }
      })
    },
  }
}
</script>

<style lang="scss" scoped></style>
